# [anarres](anarres)

**AN**ti **A**uthoritarian **R**ecursive **RES**olver

## How to avoid censorship at the DNS level?

[**Tor**](https://www.torproject.org/) provides a built-in **DNS forwarder**.

This is a minimal **Docker** container that uses a local caching DNS server ([**dnsmasq**](https://dnsmasq.org)) which will compensate for **TorDNS** being a little slower than traditional DNS servers.

## Usage

Build it using:

    docker build --pull --rm -f Dockerfile -t anarres:latest .

Run it using:

    docker run --rm -d -p 53:53/udp anarres:latest

Test it using:

    dig @127.0.0.1 cr.yp.to

Expected output:

    ; <<>> DiG 9.11.5-P4-5.1+deb10u6-Debian <<>> @127.0.0.1 cr.yp.to
    ; (1 server found)
    ;; global options: +cmd
    ;; Got answer:
    ;; ->>HEADER<<- opcode: QUERY, status: NOERROR, id: 35649
    ;; flags: qr rd ra; QUERY: 1, ANSWER: 1, AUTHORITY: 0, ADDITIONAL: 0

    ;; QUESTION SECTION:
    ;cr.yp.to. IN A

    ;; ANSWER SECTION:
    cr.yp.to. 3600 IN A 131.193.32.109

    ;; Query time: 278 msec
    ;; SERVER: 127.0.0.1#53(127.0.0.1)
    ;; WHEN: Fri Mar 18 17:13:00 CET 2022
    ;; MSG SIZE  rcvd: 42
